summaryrefslogtreecommitdiff
path: root/tests/rm/cycle
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2003-01-04 09:01:04 +0000
committerJim Meyering <jim@meyering.net>2003-01-04 09:01:04 +0000
commit432a5017a2db3b71bd007b277617499cf35b3ba1 (patch)
tree45f304842496bd6b7351c6e8aa5b98f0b7122610 /tests/rm/cycle
parent5a0e8b1ab1ac6038596282a0eafc9a79c7814723 (diff)
downloadcoreutils-432a5017a2db3b71bd007b277617499cf35b3ba1.tar.xz
rm could be tricked into mistakenly reporting a cycle
Diffstat (limited to 'tests/rm/cycle')
-rwxr-xr-xtests/rm/cycle39
1 files changed, 39 insertions, 0 deletions
diff --git a/tests/rm/cycle b/tests/rm/cycle
new file mode 100755
index 000000000..4d3467bff
--- /dev/null
+++ b/tests/rm/cycle
@@ -0,0 +1,39 @@
+#!/bin/sh
+# rm (coreutils-4.5.4) could be tricked into mistakenly reporting a cycle.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ rm --version
+fi
+
+. $srcdir/../lang-default
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+mkdir -p a/b
+touch a/b/file
+chmod u-w a/b
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+rm -rf a a 2>&1 | sed 's/:[^:]*$//' > out || fail=1
+cat <<\EOF > exp
+rm: cannot remove `a/b/file'
+rm: cannot remove `a/b/file'
+EOF
+
+cmp out exp || fail=1
+test $fail = 1 && diff out exp 2> /dev/null
+
+(exit $fail); exit $fail